window.onload = function() {
    var lstOrder;
    var index = 0;
    var orderDetailType = 1;  //打开订单详情类型,1-采集订单数据,2-同步物流信息
    var lstTaoBaoOrder;
    chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {

        // ============ 公用js函数 开始 =========== //

        if (request.type === 'sendAjaxCheckUser') {  //执行ajax-检测是否已登录
            $.ajax({
                url: lxrDomain + 'user.php?act=checkIsLogin',
                success: function(res) {
                    sendResponse({
                        type: res.code == 1 ? 'isLogin' : 'noLogin',
                    });
                }
            });
        } else if (request.type === 'addLstOrder') {  //通用 === 添加待同步的订单数据
            index = 0;
            lstOrder = [...new Set(request.lstOrder)];  //去重
            lstTaoBaoOrder = request.lstTaoBaoOrder;
            sendResponse(lstOrder[index]);  //返回响应信息打开页面--因为要兼容搜狗浏览器,所以不直接window.opne(),因为搜狗在bg里不执行
        } else if (request.type === 'nextOrder') {  //通用 === 采集下个订单详情

            //普通页面进来,直接返回true
            if (!lstOrder) return true;

            var url = lstOrder[index];

            request.data.forEach(function (objData) {
                objData.orderUrl = url;
            });

            //赋值
            lstOrder[index] = request.data;

            index ++;
            var objNextOrder = lstOrder[index];

            if (objNextOrder) {  //有数据,则采集下个订单详情
                sendResponse({
                    type: 'next',
                    url: objNextOrder
                });
            } else {  //无数据,采集完毕,发送数据到项目中

                //扁平化
                var lstNewOrder = [];
                lstOrder.forEach(function (objOrder) {
                    objOrder.forEach(function (value) {
                        lstNewOrder.push(value);
                    });
                });
                lstOrder = lstNewOrder;

                if (lstTaoBaoOrder) {  //淘宝,需要修改真实的产品价格,因为详情页里拿到的价格是原价
                    lstTaoBaoOrder.forEach(function (objTaoBaoOrder) {
                        lstOrder.forEach(function (objOrder, key) {
                            if (getQueryVariable('trade_id', objOrder.itemUrl) == objTaoBaoOrder.tradeId) {
                                lstOrder[key].price = objTaoBaoOrder.price;
                            }
                        });
                    });
                }

                $.ajax({
                    url: lxrDomain + 'user.php?act=collectTbOrder',
                    method: 'POST',
                    data: {
                        lstProduct: JSON.stringify(lstOrder)
                    },
                    success: function (res) {
                        if (res.code != 0) {
                            alert('系统错误');
                            return;
                        }
                        sendResponse({type: 'complete'});

                        sendMsgToTab('tbList', {type: "collectComplete"});

                        //通知所有页面,采集完成
                        chrome.tabs.query({}, function(tabs) {
                            tabs.forEach(function (tab) {
                                if (tab.url.indexOf('buyertrade.taobao.com') != -1) {
                                    chrome.tabs.sendMessage(tab.id, {type: "collectComplete"});
                                }
                            });
                        });
                    }
                });

                lstOrder = undefined;

            }

        }

        // ============ 公用js函数 结束 =========== //

        return true;

    })
};

//获取淘宝当前页面的列表数据
chrome.webRequest.onBeforeRequest.addListener(details => {
    if (details.url.indexOf('trade/itemlist/asyncBought') != -1 && details.method == 'POST') {
        var formData = details.requestBody.formData;
        var search = '';
        for(var key  in formData){
            search += '&' + key + '=' + formData[key];
        }
        chrome.tabs.query({active: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, {
                type: "taoBaoUrl",
                url: details.url + search
            });
        });
    }
}, {urls: ["<all_urls>"]}, ['requestBody']);

chrome.webRequest.onCompleted.addListener(details => {
    if (
        (details.url.indexOf('trade/itemlist/asyncBought') != -1 && details.method == 'POST')  //淘宝/天猫
    ) {
        addBtn();
    }

    if (details.url.indexOf('ueryInvoice') != -1) {  //苏宁订单详情页获取物流信息
        chrome.tabs.query({active: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, {type: "isOk"});
        });
    }

    if (details.url.indexOf('getOrderTrackInfoMultiPackage') != -1) {  //京东订单详情页获取物流信息
        setTimeout(function () {
            chrome.tabs.query({active: true}, function(tabs) {
                chrome.tabs.sendMessage(tabs[0].id, {type: "init"});
            });
        }, 100);
    }

    if (details.url.indexOf('getUnionOrderExtList') != -1) {  //唯品会列表获取到ajax数据
        chrome.tabs.query({active: true}, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, {type: "init"});
        });
    }

    if (details.url.indexOf('order/queryOrderList.do') != -1 && details.method == 'GET') {  //苏宁列表获取到ajax数据
        setTimeout(function () {
            chrome.tabs.query({active: true}, function(tabs) {
                chrome.tabs.sendMessage(tabs[0].id, {type: "init"});
            });
        }, 100);
    }

    if (details.url.indexOf('getShipList') != -1) {  //国美列表获取到ajax数据
        setTimeout(function () {
            chrome.tabs.query({active: true}, function(tabs) {
                chrome.tabs.sendMessage(tabs[0].id, {type: "init"});
            });
        }, 100);
    }

    if (details.url.indexOf('getShipDeliveryInfo') != -1) {  //国美详情获取到ajax数据
        setTimeout(function () {
            chrome.tabs.query({active: true}, function(tabs) {
                chrome.tabs.sendMessage(tabs[0].id, {type: "init"});
            });
        }, 100);
    }

}, {urls: ["<all_urls>"]});


function addBtn() {
    chrome.tabs.query({active: true}, function(tabs) {
        chrome.tabs.sendMessage(tabs[0].id, {type: "addBtn"});
    });
}

//发送消息给主页面,刷新页面
function sendMsgToTab(indexOf, data) {
    chrome.tabs.query({}, function(tabs) {
        tabs.forEach(function (tab) {
            if (tab.url.indexOf(indexOf) != -1) {
                console.log(tab);
                console.log(data);
                chrome.tabs.sendMessage(tab.id, data);
            }
        });
    });
}