//当前淘宝列表url,用于获取真实价格
var taoBaoUrl = 'https://buyertrade.taobao.com/trade/itemlist/asyncBought.htm?action=itemlist/BoughtQueryAction&event_submit_do_query=1&_input_charset=utf8&pageNum=1&pageSize=15';

//是否采集所有订单
var isCollectAllOrder = false;

//添加按钮
addBtn();

//采集选中订单
$(document).on('click', '.collectOrder', function () {

    isCollectAllOrder = false;

    var $lstCheckedOrder = $('table input[type=checkbox]:checked');

    if ($lstCheckedOrder.length == 0) {
        showTips('请选择订单');
        return;
    }

    collect();
});

function collect() {
    showLoading('正在采集中 ...', 8000);

    checkUser(function () {

        var $lstCheckbox = $('.lxrCheckbox:checked');
        if ($lstCheckbox.length == 0) {
            showTips('请选择订单');
            return;
        }

        var lstOrder = [];
        var lstOrderNo = [];
        $lstCheckbox.each(function () {
            lstOrderNo.push($($(this).parents('td').find('span')[5]).text().trim());
            var $parent = $(this).parents('.bought-table-mod__table___AnaXt.bought-wrapper-mod__table___3xFFM');
            lstOrder.push('https:' + $parent.find('#viewDetail').attr('href'));
        });

        $.ajax({
            url: taoBaoUrl,
            success: function (res) {

                var lstTaoBaoOrder = [];
                JSON.parse(res).mainOrders.forEach(function (objTaoBaoOrder) {
                    objTaoBaoOrder.subOrders.forEach(function (objSubOrder) {
                        var tradeId = getQueryVariable('tradeID', objSubOrder.itemInfo.snapUrl);
                        if (!objSubOrder.id) return;
                        if (!tradeId) return;
                        if (lstOrderNo.indexOf(objTaoBaoOrder.id) == -1) return;
                        lstTaoBaoOrder.push({
                            tradeId: tradeId,
                            price: objSubOrder.priceInfo.realTotal
                        });
                    });
                });

                chrome.runtime.sendMessage({
                    type: 'addLstOrder',
                    lstTaoBaoOrder: lstTaoBaoOrder,
                    lstOrder: lstOrder,
                }, function (url) {
                    window.open(url);
                });

                layer.closeAll();

            }
        });

    });
}

//采集所有订单
$(document).on('click', '.collectAllOrder', function () {
    var option = {
        icon: 1,
        shadeClose: true,
        title: '温馨提示',
        success: function () {
            var url = chrome.extension.getURL('static/layer/theme/default/icon.png');
            $('.layui-layer-ico.layui-layer-ico1').css('background', 'url(' + url + ') no-repeat');
        }
    };
    layer.confirm('采集所有订单需要耗费较长时间,请耐心等待', option, function () {
        isCollectAllOrder = true;
        var $firstPageBtn = $('#tp-bought-root > div.row-mod__row___1aPep.js-actions-row-bottom > div:nth-child(2) > ul > li.pagination-item.pagination-item-1');
        if ($firstPageBtn.hasClass('pagination-item-active')) {
            $('.lxrCheckbox').prop('checked', true);
            collect();
        } else {
            $firstPageBtn.click();
        }
    });
});

//添加按钮
function addBtn() {
    //删除原本的复选框
    $('.collectOrder, .lxrCheckbox, .lxrCheckboxAll, .collectAllOrder').remove();
    $('input[type=checkbox]').hide();

    //添加按钮
    var str = '<label class="lxrCheckboxAll"><input type="checkbox">全选</label>';
    str += '<button type="submit" class="layui-btn layui-btn-danger layui-btn-sm collectOrder">采集订单</button>';
    str += '<button type="submit" class="layui-btn layui-btn-normal layui-btn-sm collectAllOrder">采集所有订单</button>';
    $('.batch-mod__container___sK68S').before(str);

    //添加复选框
    $('[class*=create-time]').each(function () {
        var statusName = $(this).parents('table').find('tbody:nth-child(3) > tr:nth-child(1) > td:nth-child(6) > div > p > span').text();

        if (
            statusName.indexOf('取消') != -1 ||
            statusName.indexOf('关闭') != -1 ||
            statusName.indexOf('退款') != -1
            // statusName.indexOf('待支付') != -1 ||
            // statusName.indexOf('未支付') != -1 ||
            // statusName.indexOf('待付款') != -1 ||
            // statusName.indexOf('未付款') != -1 ||
            // statusName.indexOf('等待买家付款') != -1
        ) return;
        $(this).before('<input class="lxrCheckbox" type="checkbox">');
    });

    if (isCollectAllOrder) {
        $('.lxrCheckbox').prop('checked', true);
        collect();
    }
}

chrome.runtime.onMessage.addListener(function(request) {
    if (request.type == 'addBtn') addBtn();
    if (request.type == 'taoBaoUrl') taoBaoUrl = request.url;
    if (request.type == 'collectComplete') {
        if (isCollectAllOrder) {
            var $btn = $('#tp-bought-root > div.row-mod__row___1aPep.js-actions-row-top > div:nth-child(2) > div > button:nth-child(2)');
            if ($btn.length == 0 || $btn.attr('disabled') == 'disabled') {
                showSuccess('采集成功', function () {
                    window.location.reload();
                });
                return;
            }
            $btn.click();
        }
    }
});